/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#include <gst/gstbuffer.h>
#include <gst/gsttype.h>


/* Buffer signals and args */
enum {
  /* FILL ME */
  LAST_SIGNAL
};

enum {
  ARG_0,
  /* FILL ME */
};


static void gst_buffer_class_init(GstBufferClass *klass);
static void gst_buffer_init(GstBuffer *buffer);


static GstObject *parent_class = NULL;
static guint gst_buffer_signals[LAST_SIGNAL] = { 0 };

GtkType
gst_buffer_get_type(void) {
  static GtkType buffer_type = 0;

  if (!buffer_type) {
    static const GtkTypeInfo buffer_info = {
      "GstBuffer",
      sizeof(GstBuffer),
      sizeof(GstBufferClass),
      (GtkClassInitFunc)gst_buffer_class_init,
      (GtkObjectInitFunc)gst_buffer_init,
      (GtkArgSetFunc)NULL,
      (GtkArgGetFunc)NULL,
      (GtkClassInitFunc)NULL,
    };
    buffer_type = gtk_type_unique(GST_TYPE_OBJECT,&buffer_info);
  }
  return buffer_type;
}

static void
gst_buffer_class_init(GstBufferClass *klass) {
  GtkObjectClass *gtkobject_class;

  gtkobject_class = (GtkObjectClass*)klass;

  parent_class = gtk_type_class(GST_TYPE_OBJECT);
}

static void gst_buffer_init(GstBuffer *buffer) {
}

/**
 * gst_buffer_new:
 *
 * Create a new buffer.
 *
 * Returns: new buffer
 */
GstBuffer *gst_buffer_new() {
  GstBuffer *buffer;

  buffer = GST_BUFFER(gtk_type_new(gst_buffer_get_type()));
  return buffer;
}

void gst_buffer_destroy(GstBuffer *buffer) {
  g_return_if_fail(buffer != NULL);
  g_return_if_fail(GST_IS_BUFFER(buffer));
  
  gtk_object_destroy(GTK_OBJECT(buffer));
}

void gst_buffer_ref(GstBuffer *buffer) {
  g_return_if_fail(buffer != NULL);
  g_return_if_fail(GST_IS_BUFFER(buffer));

  buffer->refcount++;
}

void gst_buffer_ref_by_count(GstBuffer *buffer,gint count) {
  g_return_if_fail(buffer != NULL);
  g_return_if_fail(GST_IS_BUFFER(buffer));

  buffer->refcount += count;
}

void gst_buffer_unref(GstBuffer *buffer) {
  g_return_if_fail(buffer != NULL);
  g_return_if_fail(GST_IS_BUFFER(buffer));

  buffer->refcount--;
}

