#include <gst/gstmeta.h>
#include <gst/gsttrace.h>


void gst_meta_ref(GstMeta *meta) {
  g_return_if_fail(meta != NULL);

  gst_trace_add_entry(NULL,0,meta,"ref meta");
  meta->refcount++;
}

void gst_meta_unref(GstMeta *meta) {
  g_return_if_fail(meta != NULL);

  gst_trace_add_entry(NULL,0,meta,"unref meta");
  meta->refcount--;

  if (meta->refcount == 0) {
    gst_trace_add_entry(NULL,0,meta,"destroy meta");
    if (meta->destroy)
      (meta->destroy)(meta);
    else
      g_free(meta);
  }
}


GstMeta *gst_meta_cow(GstMeta *meta) {
  g_return_if_fail(meta != NULL);
}
